/***************************************************************************
 *   Copyright (C) 2009 - 2010 by Dr. Oliver Heidbüchel                    *
 *                         (post@oliver-heidbuechel.de)                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#ifndef SPARQL_QUERYTAB_H
#define SPARQL_QUERYTAB_H
 
#include <KTextEdit>

#include <Soprano/Soprano>

#include <QContextMenuEvent>
#include <QSplitter>
#include <QTableWidget>

 
class SparqlQueryTab : public QSplitter
{
  Q_OBJECT
 
  public:
    SparqlQueryTab(Soprano::Model *model, QWidget *parent = 0);
    void executeQuery(const QString &);
 
  private:
    KTextEdit* queryField;
    QTableWidget* resultField;
    Soprano::Model* model;

  protected:
    virtual void contextMenuEvent(QContextMenuEvent* event);
    
  private slots:
    void query();
    
  signals:
    void asSubjectSelected(const QString &);
    void asPredicateSelected(const QString &);
    void asObjectSelected(const QString &);
    void asContextSelected(const QString &);
    void newQueryCommisioned(const QString &);
};
 
#endif

