/***************************************************************************
 *   Copyright (C) 2009 - 2010 by Dr. Oliver Heidbüchel                    *
 *                         (post@oliver-heidbuechel.de)                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#ifndef STATEMENTWIDGET_H
#define STATEMENTWIDGET_H
 
#include <KLineEdit>

#include <Soprano/Soprano>

#include <QString>

 
class StatementWidget : public QWidget
{
  Q_OBJECT
 
  public:
    StatementWidget(Soprano::Model* model, QWidget *parent = 0);
 
  private:
    KLineEdit* subjectField;
    KLineEdit* predicateField;
    KLineEdit* objectField;
    KLineEdit* contextField;
    Soprano::Model* model;
    
    QString removeBrackets(const QString &text);
    QString bracketsToHTML(const QString &text);
    QString removeQuotationMarks(const QString &text);
    Soprano::Node createNodeForStatement(const QString &text);

  private slots:
    void setSubject(const QString &);
    void setPredicate(const QString &);
    void setObject(const QString &);
    void setContext(const QString &);
    void addStatement();
    void removeStatements();
};
 
#endif

